#ifndef SC_COUNTING_HH_
#define SC_COUNTING_HH_

#include "ell/StateCollector.hh"

namespace ell
{
	/*!
	 * This class simply keeps track of the number of added States. 
	 * 
	 * @author Daniel Maticzka
	 */
	class SC_Counting : public StateCollector
	{
	protected:
	
		  //! the last added State
		State* lastAdded;
		  //! the number of added States
		size_t stateCount;
		
	public:	
	
		SC_Counting();
		
		virtual
		~SC_Counting();
	
		  //! Increments State counter.
		  //! @param s the added State
		virtual void add(const State& s);
		
		  //! Returns number of added States.
		  //! @return the number of added states
		virtual size_t size() const;
		 
		  //! Returns last added State.
		  //! @return last added State
		virtual const State* const getLastAdded() const;
		
	};
	
} // namespace ell

#endif /*SC_COUNTING_HH_*/
